// Teil des Projekts "LinADT" -- Keller und Schlange -- Umgebung fr Aufgaben 20 und 21
// R. Krell (www.r-krell.de) zu Seite 14 von "keller-und-schlange_(r-krell).pdf, 22.12.2006
// Diese Datei nicht verndern, nur ADT_TauschKellerX und ADT_ErwSchlangeX ergnzen!

public abstract class ADT_DynSpeicherMitEndzugriff implements ADT_Speicher
// Nachtrag: Abstrakte Oberflche fr neue Vererbung
{
  protected ADT_Knoten kopf; // Verankerung der Struktur

  public ADT_DynSpeicherMitEndzugriff() // Konstruktor
  {
    kopf = null;
  }

  public boolean istLeer() // sagt, ob der Speicher leer ist
  {                        // genau dann wahr, wenn der Speicher leer ist
    return (kopf == null);
  }

  public Object zeige()    // zeigt/kopiert oberstes Element, ohne Speicher zu ndern
  {
    return (kopf.holeInhalt());
  }

  public Object raus()     // zeigt oberstes El. und entfernt es aus dem Speicher
  {
    Object altesElement = kopf.holeInhalt();
    kopf = kopf.holeNachbarKnoten();
    return (altesElement);
  }
  
  public abstract void rein (Object neuesElement); // bergebenes Element kommt in Speicher
  // Methode wird von Keller und Schlange verschieden implementiert!


}

