// Teil des Projekts typisierte lineare abstrakte Datentypen -- nur ab Java (1.)5
// R. Krell (www.r-krell.de) -- 21.12.2006 -- Java JDK 1.5+ ntig

public abstract class TADT_DynSpeicherMitEndzugriff<Elementtyp> implements TADT_Speicher<Elementtyp>
// Nachtrag: Abstrakte Oberflche fr neue Vererbung
{
  protected TADT_Knoten<Elementtyp> kopf; // Verankerung der Struktur

  public TADT_DynSpeicherMitEndzugriff()  // Konstruktor
  {
    kopf = null;
  }

  public boolean istLeer() // sagt, ob der Speicher leer ist
  {                        // genau dann wahr, wenn der Speicher leer ist
    return (kopf == null);
  }

  public Elementtyp zeige()    // zeigt/kopiert oberstes Element, ohne Speicher zu ndern
  {
    return (kopf.holeInhalt());
  }

  public Elementtyp raus()     // zeigt oberstes El. und entfernt es aus dem Speicher
  {
    Elementtyp altesElement = kopf.holeInhalt();
    kopf = kopf.holeNachbarKnoten();
    return (altesElement);
  }
  
  public abstract void rein (Elementtyp neuesElement); // bergebenes Element kommt in Speicher
  // Methode wird von Keller und Schlange verschieden implementiert!


}

