// Teil des Projekts typisierte lineare abstrakte Datentypen -- nur ab Java (1.)5
// R. Krell (www.r-krell.de) -- 21.12.2006 -- Java JDK 1.5+ ntig

public class TADT_Schlange<Elementtyp> extends TADT_DynSpeicherMitEndzugriff<Elementtyp>
// Nachtrag: Implementation, die von abstrakter Oberklasse erbt und nur rein neu schreibt
// und zustzlich den schwanz einfhrt
{
  protected TADT_Knoten<Elementtyp> schwanz; // kopf existiert schon im und durch abstrakte Oberklasse

  public TADT_Schlange ()
  {
    super();        // ** hier kein super<Elementtyp>(); erlaubt !**
                    // Konstruktor der abstr. Oberkl. TADT_DynSpeicherMitEndzugriff aufrufen
    schwanz = null; // zustzlich
  }

  public void rein (Elementtyp neuesElement)  // neu (anstelle abstrakter Klasse)
  {
    TADT_Knoten<Elementtyp> neu = new TADT_Knoten<Elementtyp> (neuesElement, null);
    if (istLeer())
    {
      kopf = neu;   //1. Element: auch kopf muss auf den neuen Knoten zeigen
    }               //hierfr darf kopf hchstens 'protected', nicht 'private' sein.
    else
    {
      schwanz.ndereNachbarn(neu);  //sonst: Vorgnger muss auf den neuen Knoten zeigen
    }
    schwanz = neu;  //immer zeigt auch der Schwanz auf den letzten Knoten
  }
}

