// Teil des Projekts typisierte lineare abstrakte Datentypen -- nur ab Java (1.)5
// R. Krell (www.r-krell.de) -- 21.12.2006 -- Java JDK 1.5+ ntig

public class TADT_Schlange1<Elementtyp> extends TADT_StatSpeicherMitEndzugriff<Elementtyp>
// Schlange als Erbe der abstrakten Oberklasse mit zustzl. Definitionen
{
  protected int schwanz;

  public TADT_Schlange1()       // Konstruktor fr neue, leere Schlange
  {
    super();
    schwanz = 0;                // weil noch nichts da ist, steht der schwanz noch
  }                             // rechts' vom knftigen 1. El. bei -1 = MAX-1
  
  public void rein (Elementtyp element) // bergebenes Element kommt in Speicher
  {
    schwanz = (schwanz+MAX-1) % MAX;  // Neue Elemente stehen links von vorhandenen
    reihung[schwanz] = element;   // das letzte eingeschlangte (=hinterste) Element
  }                            // steht am Index schwanz
  
  public boolean istLeer()     // sagt, ob der Speicher leer ist
  {
    return ((kopf+1)%MAX == schwanz);  // schwanz berholt kopf gerade
  }
}

