// Teil des Projekts "LinADT" -- Keller und Schlange -- Umgebung fr Aufgaben 20 und 21
// R. Krell (www.r-krell.de) zu Seite 14 von "keller-und-schlange_(r-krell).pdf, 22.12.2006
// Diese Datei nicht verndern, nur ADT_TauschKellerX und ADT_ErwSchlangeX ergnzen!

import java.awt.*;
import java.awt.event.*;

public class ADT_Oberflaeche3 extends Frame
// Oberflche zum Testen des Kellers bzw. weiterer LinADTs
{
  TextField eingabe = new TextField("",8);
  TextArea ausgabe = new TextArea("Zuerst einen LinADT mit den oberen beiden Tastenreihen whlen!\n",10,95);
  CheckboxGroup cbg = new CheckboxGroup();
  Checkbox cbZahl, cbZchn, cbText;
  Button knKellerReih, knKellerDyn, knKellerTa, knKellerTb, knKellerTc,
    knSchlangeReih, knSchlangeDyn, knSchlangeEa, knSchlangeEb, knSchlangeEc,
    knRein, knRaus, knZeige, knLeer, knTausche, knZhle;// Knpfe definieren
  
  ADT_Speicher datenSpeicher; // Definieren eines allgemeinen LinADTs namens datenSpeicher
  String SpezialTyp =""; // fr sichere Typ-Bestimmung der Spezialtypen aus den Hausaufgaben

  public void richteFensterEin() // Fenster initalisieren und beschreiben
  {
    //WindowsListener hinzufgen, damit Schlieknopf funktioniert
    addWindowListener (    
      new WindowAdapter ()
      {
        public void windowClosing (WindowEvent ereignis)
        {                
          setVisible (false);
          dispose();  
          System.exit(0);
        }
      }
    ); // runde Klammer vom Windowlistener geschlossen;  
    
    setTitle("Testprogramm fr lineare abstrakte Datentypen und Hausaufgaben"); // Fenster mit Titel versehen
    setSize (725,320); // Fenstergre (Breite und Hhe in Pixeln) festlegen
  }  
   
  public void richteRadiobuttonsEin()
  {
    cbZahl = new Checkbox ("Zahl", cbg, false);
    cbZchn = new Checkbox ("Zeichen", cbg, false);
    cbText = new Checkbox ("Text", cbg, true);
  }
  
  public void richteKnpfeEin()
  {     
    // Knpfe erzeugen:
    knKellerReih     = new Button ("Keller (stat.: Reihung)");
    knKellerDyn      = new Button ("Keller (dyn.: Knoten)");
    knKellerTa       = new Button ("TauschKeller a (abstr)");
    knKellerTb       = new Button ("TauschKeller b (Reihg.)");
    knKellerTc       = new Button ("TauschKeller c (Knoten)");
    knSchlangeReih   = new Button ("Schlange (statisch)");
    knSchlangeDyn    = new Button ("Schlange (dynamisch)");
    knSchlangeEa     = new Button ("ErwSchlange a (Knoten)");
    knSchlangeEb     = new Button ("ErwSchlange b (abstr)");
    knSchlangeEc     = new Button ("ErwSchlange c (Zhler)");
    knRein           = new Button ("rein");
    knRaus           = new Button ("raus");
    knZeige          = new Button ("zeige");
    knLeer           = new Button ("istLeer ?");
    knTausche        = new Button ("tausche");
    knZhle          = new Button ("zhle");
        
    //Funktion der Knpfe festlegen:
    
    knKellerReih.addActionListener (
      new ActionListener () 
      { 
        public void actionPerformed (ActionEvent e) 
        { 
         datenSpeicher = new ADT_Keller1 (); // Erzeugen von datenSpeicher
           // als spezieller Keller mit Reihung
         ausgabe.append ("Ein neuer leerer Keller wurde in/mit einer Reihung erzeugt.\n"); 
         SpezialTyp = "";
         eingabe.requestFocus(); // aktviert die Eingabezeile,  
          // sodass knftige Tastatureingaben automatisch in der eingabe landen  
         eingabe.selectAll(); // macht evtl. Text in der Eingabezeile blau, 
          // sodass alter Text automatisch berschrieben wird 
        } 
      });

    knKellerDyn.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
         datenSpeicher = new ADT_Keller (); // Erzeugen von datenSpeicher
          // als spezieller dynamischer Keller
         ausgabe.append ("Ein neuer leerer Keller wurde dynamisch mit rekursiven Knoten erzeugt.\n");
         SpezialTyp = "";
         eingabe.requestFocus();
         eingabe.selectAll();
        }
      });

    knKellerTa.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
         datenSpeicher = new ADT_TauschKellerA (); // Erzeugen von datenSpeicher
          // als spezieller dynamischer Keller
         ausgabe.append ("Ein neuer leerer Tausch-Keller (Aufgabe 2a) wurde erzeugt.\n");
         SpezialTyp = "2a";
         eingabe.requestFocus();
         eingabe.selectAll();
        }
      });

    knKellerTb.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
         datenSpeicher = new ADT_TauschKellerB (); // Erzeugen von datenSpeicher
          // als spezieller dynamischer Keller
         ausgabe.append ("Ein neuer leerer Tausch-Keller (Aufgabe 2b) wurde erzeugt.\n");
         SpezialTyp = "2b";
         eingabe.requestFocus();
         eingabe.selectAll();
        }
      });
      
    knKellerTc.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
         datenSpeicher = new ADT_TauschKellerC (); // Erzeugen von datenSpeicher
          // als spezieller dynamischer Keller
         ausgabe.append ("Ein neuer leerer Tausch-Keller (Aufgabe 2c) wurde erzeugt.\n");
         SpezialTyp = "2c";
         eingabe.requestFocus();
         eingabe.selectAll();
        }
      });

    knSchlangeReih.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
         datenSpeicher = new ADT_Schlange1 (); // Erzeugen von datenSpeicher
         ausgabe.append ("Eine neue leere Schlange wurde in/mit einer Reihung erzeugt.\n");
         SpezialTyp = "";
         eingabe.requestFocus(); 
         eingabe.selectAll(); 
        } 
      });  

    knSchlangeDyn.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
          datenSpeicher = new ADT_Schlange(); // Erzeugen von datenSpeicher
           // als dynamische Schlange
          ausgabe.append ("Eine neue leere Schlange wurde dynamisch mit rekursiven Knoten erzeugt.\n");
          SpezialTyp = "";
          eingabe.requestFocus();
          eingabe.selectAll();
        }
      });

    knSchlangeEa.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
          datenSpeicher = new ADT_ErwSchlangeA(); // Erzeugen von datenSpeicher
           // als dynamische Schlange
          ausgabe.append ("Eine neue leere erweiterte Schlange (Aufgabe 3a) wurde erzeugt.\n");
          SpezialTyp = "3a";
          eingabe.requestFocus();
          eingabe.selectAll();
        }
      });

    knSchlangeEb.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
          datenSpeicher = new ADT_ErwSchlangeB(); // Erzeugen von datenSpeicher
           // als dynamische Schlange
          ausgabe.append ("Eine neue leere erweiterte Schlange (Aufgabe 3b) wurde erzeugt.\n");
          SpezialTyp = "3b";
          eingabe.requestFocus();
          eingabe.selectAll();
        }
      });

    knSchlangeEc.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
          datenSpeicher = new ADT_ErwSchlangeC(); // Erzeugen von datenSpeicher
           // als dynamische Schlange
          ausgabe.append ("Eine neue leere erweiterte Schlange (Aufgabe 3c) wurde erzeugt.\n");
          SpezialTyp = "3c";
          eingabe.requestFocus();
          eingabe.selectAll();
        }
      });
      
    knRein.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
           String ein = eingabe.getText();
           String aus = "???";
           Object Obj = null;
           eingabe.requestFocus();
           eingabe.selectAll();
           if (ein.equals(""))
           {
             ausgabe.append ("** Erst Element eingeben, das rein soll! **\n");
           }
           else
           {
             if (cbZahl.getState())
             {
               Obj = new Double (ein);
               aus = "Zahl "+Obj.toString();
             }
             else if (cbZchn.getState())
             {
               Obj = new Character (ein.charAt(0));
               aus = "Zeichen '"+Obj.toString()+"'";
               eingabe.select(0,1);
             }
             else if (cbText.getState())
             {
               Obj = ein;
               aus = "Zeichenkette \""+ein+"\"";
             }
             try
             {
               datenSpeicher.rein (Obj);
               ausgabe.append (""+aus+" gespeichert!\n");
             }
             catch (Exception f)
             {
               ausgabe.append ("** "+f+"\n");
             }
           }
        }       
      });

        
    knRaus.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {        
          eingabe.requestFocus();
          eingabe.selectAll();
          Object Obj = null;
          String aus = "???";
          try
          {
            Obj = datenSpeicher.raus();
            if (Obj instanceof Double)
            { 
               aus = "Zahl "+Obj;
            }
            else if (Obj instanceof Character)
            { 
               aus = "Zeichen '"+Obj+"'";
            }
            else if (Obj instanceof String)
            { 
               aus = "Zeichenkette \""+Obj+"\"";
            }
            ausgabe.append (aus+" entfernt!\n");
          }
          catch (Exception f)
          {
            ausgabe.append ("** "+f+"\n");
          }
        }   
      });  
        
    knZeige.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {        
          eingabe.requestFocus();
          eingabe.selectAll();
          Object Obj = null;
          String aus = "???";
          try
          {
            Obj = datenSpeicher.zeige();
            if (Obj instanceof Double)
            { 
               aus = "Zahl "+Obj;
            }
            else if (Obj instanceof Character)
            { 
               aus = "Zeichen '"+Obj+"'";
            }
            else if (Obj instanceof String)
            { 
               aus = "Zeichenkette \""+Obj+"\"";
            }
            ausgabe.append (aus+" ist vorne/oben.\n");
          }
          catch (Exception f)
          {
            ausgabe.append ("** "+f+"\n");
          }
        }   
      });  

    knLeer.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {        
          eingabe.requestFocus();
          eingabe.selectAll();
          // Hier kein try-catch, obwohl auch Fehler NullPointerException entstehen kann,
          // nmlich wenn Knopf gedrckt, bevor Keller erzeugt wurde
          if (datenSpeicher.istLeer())
          {
            ausgabe.append ("Der Speicher ist im Moment leer!\n");
          }
          else
          {
            ausgabe.append ("Der Speicher ist im Moment nicht leer!\n");
          }
        }   
      });  
      
    knTausche.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
          eingabe.requestFocus();
          eingabe.selectAll();

          if (SpezialTyp.equals("2a"))   // ntig, weil ADT_Speicher kein tausche kennt.
          {
            ADT_TauschKellerA kA = (ADT_TauschKellerA) datenSpeicher;
            kA.tausche();  // ntig, weil ADT_Speicher kein tausche kennt.
            ausgabe.append ("Oberste beide Elemente im Tauschkeller a wurden vertauscht!\n");
          }
          else if (SpezialTyp.equals("2b"))
          {
            ADT_TauschKellerB kB = (ADT_TauschKellerB) datenSpeicher;
            kB.tausche();
            ausgabe.append ("Oberste beide Elemente im Tauschkeller b wurden vertauscht!\n");
          }
          else if (SpezialTyp.equals("2c"))
          {
            ADT_TauschKellerC kC = (ADT_TauschKellerC) datenSpeicher;
            kC.tausche();
            ausgabe.append ("Oberste beide Elemente im Tauschkeller c wurden vertauscht!\n");
            // komischerweise geht nicht: ((ADT_TauschKellerC).datenSpeicher).tausche();
          }
          else
          {
            ausgabe.append ("** Nichts gemacht: Tauschen nur bei den TauschKellern mglich!\n");
          }
        }
      });

    knZhle.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
          eingabe.requestFocus();
          eingabe.selectAll();
          int zahl = -99;

          if (SpezialTyp.equals("3a"))
          {
            ADT_ErwSchlangeA sA = (ADT_ErwSchlangeA) datenSpeicher;
            zahl = sA.nenneElementzahl();  // ntig, weil ADT_Speicher kein nenneElementzahl kennt.
          }
          else if (SpezialTyp.equals("3b"))
          {
            ADT_ErwSchlangeB sB = (ADT_ErwSchlangeB) datenSpeicher;
            zahl = sB.nenneElementzahl();
          }
          else if (SpezialTyp.equals("3c"))
          {
            ADT_ErwSchlangeC sC = (ADT_ErwSchlangeC) datenSpeicher;
            zahl = sC.nenneElementzahl();
            // komischerweise geht nicht: ((ADT_ErwSchlangeC).datenSpeicher).nenneElementzahl();
          }
          if (SpezialTyp.length()>0 && SpezialTyp.charAt(0)=='3')
          {
           ausgabe.append ("Die Erweiterte Schlange hat "+zahl+" Elemente\n");
          }
          else
          {
            ausgabe.append ("** Nichts gemacht: Zhlen nur bei Erweiterten Schlangen mglich!\n");
          }
        }
      });


  } 
   
  public void fhreAus ()
  { 
    richteFensterEin();
    richteRadiobuttonsEin();
    richteKnpfeEin();      
    ausgabe.setEditable(false); // Ausgabe nicht vom Benutzer nderbar
    setLayout (new FlowLayout());

    add (knKellerReih); 
    add (knKellerDyn);
    add (knKellerTa);
    add (knKellerTb);
    add (knKellerTc);
    add (knSchlangeReih);   
    add (knSchlangeDyn);
    add (knSchlangeEa);
    add (knSchlangeEb);
    add (knSchlangeEc);
    add (eingabe);
    add (new Label(" als"));
    add (cbZahl);
    add (cbZchn);
    add (cbText);
    add (knRein);
    add (new Label(""));
    add (knLeer); add (new Label(""));
    add (knZeige); add (new Label(""));
    add (knRaus); add (new Label(""));
    add (knTausche);
    add (knZhle);
    add (ausgabe);
    setVisible(true);      
  }   
}
